library ExtFunc;
uses
  SysUtils,
  Classes;
const
  rDefault = -1E20; //No not change
type
  Float = double;
  tRoutine = array [0..10] of char;
var
  iOption: integer = 0;
  IsOpen: boolean = false;
  FileLog: text;

procedure Calling(Routine: tRoutine);
  begin
  if iOption = 1 then
    begin
    if not IsOpen then
      begin
      AssignFile(FileLog,'ExtFunc.log');
      rewrite(FileLog);
      IsOpen:=true;
      end;
    writeln(FileLog,'Calling ',Routine); flush(FileLog);
    end;
  end;
function ExtFunc1(X,Y: Float): Float; stdcall;
  begin
  Calling('ExtFunc1');
  ExtFunc1:=rDefault; //Replace rDefault by specific value if to be used
  //ExtFunc1:=(0.5*X+Y)/86400; //Example
  end;
function ExtFunc2(X,Y: Float): Float; stdcall;
  begin
  Calling('ExtFunc2');
  ExtFunc2:=rDefault; //Replace rDefault by specific value if to be used
  end;
function ExtFunc3(X,Y: Float): Float; stdcall;
  begin
  Calling('ExtFunc3');
  ExtFunc3:=rDefault; //Replace rDefault by specific value if to be used
  end;
function ExtFunc4(X,Y: Float): Float; stdcall;
  begin
  Calling('ExtFunc4');
  ExtFunc4:=rDefault; //Replace rDefault by specific value if to be used
  end;
function ExtFunc5(X,Y: Float): Float; stdcall;
  begin
  Calling('ExtFunc5');
  ExtFunc5:=rDefault; //Replace rDefault by specific value if to be used
  end;
function ExtFunc6(X,Y: Float): Float; stdcall;
  begin
  Calling('ExtFunc6');
  ExtFunc6:=rDefault; //Replace rDefault by specific value if to be used
  end;
function ExtFunc7(X,Y: Float): Float; stdcall;
  begin
  Calling('ExtFunc7');
  ExtFunc7:=rDefault; //Replace rDefault by specific value if to be used
  end;
function ExtFunc8(X,Y: Float): Float; stdcall;
  begin
  Calling('ExtFunc8');
  ExtFunc8:=rDefault; //Replace rDefault by specific value if to be used
  end;
function ExtFunc9(X,Y: Float): Float; stdcall;
  begin
  Calling('ExtFunc9');
  ExtFunc9:=rDefault; //Replace rDefault by specific value if to be used
  end;
function ExtFunc10(X,Y: Float): Float; stdcall;
  begin
  Calling('ExtFunc10');
  ExtFunc10:=rDefault; //Replace rDefault by specific value if to be used
  end;
function ExtCorr(iSide: integer; T,dT,vel,D,L,CP,Dens,DV,DVWall,KV,TC,Beta,Re,Gr,Ra,Pr: Float): Float; stdcall;
  {
  iSide  - Transfer side (1 or 2)
  T      - Bulk temperature
  dT     - Surface temperature - Bulk fluid temperature
  vel    - Fluid velocity
  D      - Hydraulic diameter
  L      - Flow length
  CP     - Fluid specific heat capacity at bulk temperature
  Dens   - Fluid density at bulk temperature
  DV     - Fluid dynamic viscosity at bulk temperature
  DVWall - Fluid dynamic viscosity at wall condition
  KV     - Fluid kinematic viscosity at bulk temperature
  TC     - Fluid thermal conductivity at bulk temperature
  Beta   - Fluid thermal volumetric expansion coefficient at bulk temperature
  Re     - Reynold number
  Gr     - Grashof number
  Ra     - Rayleigh number
  Pr     - Fluid prandtl number at bulk temperature
  }
  begin
  Calling('ExtCorr');
  ExtCorr:=rDefault; //Replace rDefault by specific value if to be used
  //ExtCorr:=1000; //Example
  end;
procedure SetOption(iOptionSet: integer); stdcall;
  begin
  iOption:=iOptionSet;
  end;
exports
 SetOption,
 ExtCorr,
 ExtFunc10,
 ExtFunc9,
 ExtFunc8,
 ExtFunc7,
 ExtFunc6,
 ExtFunc5,
 ExtFunc4,
 ExtFunc3,
 ExtFunc2,
 ExtFunc1;
begin
end.
